# ------------------------------------------------------------------------
# This file is to loop the ASTParse.py file for all the files in the datasets
# ------------------------------------------------------------------------

import os
import subprocess
import argparse

controlfolderlist = []
autopilotfolderlist = []

controlfilelist = []
autopilotfilelist = []


# ---------------------------------------------------
# To Parse All Data Files in Control Folder
# ---------------------------------------------------


def parseControlFolder(controlfolder, destinationfolder):
    for folders in os.listdir(controlfolder):
        # print(folders)
        if not folders == ".DS_Store":
            controlfolderlist.append(os.path.join(controlfolder, folders))
    # print(len(controlfolderlist))

    for eachSubFolder in controlfolderlist:
        for files in os.listdir(eachSubFolder):
            if not files == ".DS_Store":
                controlfilelist.append(os.path.join(eachSubFolder, files))

    # print(len(controlfilelist))

    for x in controlfilelist:
        subprocess.run(["python3", "ASTParser.py", x, destinationfolder])


    # ---------------------------------------------------
    # To Parse All Data Files in Autopilot Folder
    # ---------------------------------------------------


def parseAutopilotFolder(autopilotfolder, destinationfolder):
    for folders in os.listdir(autopilotfolder):
        if not folders == ".DS_Store":
            autopilotfolderlist.append(os.path.join(autopilotfolder, folders))

    for eachSubFolder in autopilotfolderlist:
        for files in os.listdir(eachSubFolder):
            if not files == ".DS_Store":
                autopilotfilelist.append(os.path.join(eachSubFolder, files))

    # print(len(autopilotfilelist))

    for x in autopilotfilelist:
        subprocess.run(["python3", "ASTParser.py", x, destinationfolder])

def parseSolutionsFolder(solutionsfolder, destinationfolder):
    for file in os.listdir(solutionsfolder):
        if not file == ".DS_Store":
            filepath = os.path.join(solutionsfolder, file)
            subprocess.run(["python3", "ASTParser.py", filepath, destinationfolder])

    # ---------------------------------------------------
    # ---------------- MAIN STARTS HERE -----------------
    # ---------------------------------------------------


def main():
    inputArgument = argparse.ArgumentParser()

    inputArgument.add_argument(
        "sourcefolder", help="Add absolute path to the parent data folder"
    )
    inputArgument.add_argument(
        "destfolder", help="Add absolute path to destination folder"
    )

    args = inputArgument.parse_args()

    parentFolderPath = args.sourcefolder
    destFolderPath = args.destfolder

    for folder in os.listdir(parentFolderPath):
        if folder == "Control":
            SourceControlDataFolder = os.path.join(parentFolderPath, folder)
        if folder == "Autopilot":
            SourceAutopilotDataFolder = os.path.join(parentFolderPath, folder)

    # print(SourceControlDataFolder)
    # print(SourceAutopilotDataFolder)

    # ---------------------------------------------------
    # To Parse All Data Files in Control Folder
    # ---------------------------------------------------

    # parseControlFolder(SourceControlDataFolder, destFolderPath)

    # ---------------------------------------------------
    # To Parse All Data Files in Autopilot Folder
    # ---------------------------------------------------

    # parseAutopilotFolder(SourceAutopilotDataFolder, destFolderPath)

    # ---------------------------------------------------
    # To Parse All Data Files in Solutions Folder 
    # consisting of human- and GPT-generated solutions
    # ---------------------------------------------------

    parseSolutionsFolder(parentFolderPath, destFolderPath)

if __name__ == "__main__":
    main()
